Module VBMisc
    Public Const PA_ERR_OK As Short = 0
    Public Const PA_ERR As Integer = 49152
    Public Const PA_ERR_BAD_PRINTER_NAME As Integer = (PA_ERR + 1)
    Public Const PA_ERR_BAD_PORT_NAME As Integer = (PA_ERR + 2)
    Public Const PA_ERR_SYSTEM As Integer = (PA_ERR + 3)
    Public Const PA_ERR_VAL_NOT_SET As Integer = (PA_ERR + 4)
    Public Const PA_ERR_STRING_TOO_LONG As Integer = (PA_ERR + 5)
    Public Const PA_ERR_PARAM1 As Integer = (PA_ERR + 6)
    Public Const PA_ERR_PARAM2 As Integer = (PA_ERR + 7)
    Public Const PA_ERR_PARAM3 As Integer = (PA_ERR + 8)
    Public Const PA_ERR_PARAM4 As Integer = (PA_ERR + 9)
    Public Const PA_ERR_NO_PRINTER_CHANGE As Integer = (PA_ERR + 10)
    Public Const PA_ERR_ACCESS As Integer = (PA_ERR + 11)
    Public Const PA_ERR_NO_PRINTERS As Integer = (PA_ERR + 12)
    Public Const PA_ERR_REASSIGN As Integer = (PA_ERR + 13)
    Public Const PA_ERR_BLOWN_POINTER As Integer = (PA_ERR + 14)
    Public Const PA_ERR_OS_UNSUPPORTED As Integer = (PA_ERR + 15)
    Public Const PA_ERR_PORT_BUSY As Integer = (PA_ERR + 16)
    Public Const PA_ERR_BAD_STAT_GROUP As Integer = (PA_ERR + 17)
    Public Const PA_ERR_BAD_STAT_FIELD As Integer = (PA_ERR + 18)
    Public Const PA_ERR_BUFFER_TOO_SMALL As Integer = (PA_ERR + 19)
    Public Const PA_ERR_INSUFFICIENT_MEM As Integer = (PA_ERR + 20)
    Public Const PA_ERR_UNKNOWN_PRINTER As Integer = (PA_ERR + 21)
    Public Const PA_ERR_PORT_HAS_SPOOLED_JOB As Integer = (PA_ERR + 22)
    Public Const PA_ERR_SHEET_NOT_FOUND As Integer = (PA_ERR + 23)
    Public Const PA_ERR_BIN_NOT_FOUND As Integer = (PA_ERR + 24)
    'Error codes for language monitor
    Public Const PA_ERR_PIPE_OPEN_BUSY As Integer = (PA_ERR + 25)
    Public Const PA_ERR_PIPE_OPEN_FAILED As Integer = (PA_ERR + 26)
    Public Const PA_ERR_PIPE_TIMEOUT As Integer = (PA_ERR + 27)
    Public Const PA_ERR_PRINTER_NOT_RESPONDING As Integer = (PA_ERR + 28)
    Public Const PA_ERR_STATUS_TIMEOUT As Int32 = (PA_ERR + 29)

    ' Error codes related to firmware reprogramming
    Public Const PA_ERR_PRINTER_NOT_READY As Integer = (PA_ERR + 31)
    Public Const PA_ERR_BIN_FILE_NOT_FOUND As Integer = (PA_ERR + 32)
    Public Const PA_ERR_BIN_FILE_BAD_EXTENTION As Integer = (PA_ERR + 33)
    Public Const PA_ERR_CAN_NOT_GET_MODEL As Integer = (PA_ERR + 34)
    Public Const PA_ERR_STATUS_READ_ERROR As Integer = (PA_ERR + 35)
    Public Const PA_ERR_INCORRECT_BIN_FILE As Integer = (PA_ERR + 36)
    Public Const PA_ERR_FLASH_NOT_ENTERED As Integer = (PA_ERR + 37)
    Public Const PA_ERR_FLASH_BAD_BIN_FILE As Integer = (PA_ERR + 38)
    Public Const PA_ERR_FLASH_REPROGRAM_FAILED As Integer = (PA_ERR + 39)
    Public Const PA_ERR_MODEL_NOT_FOUND As Integer = (PA_ERR + 40)
    Public Const PA_ERR_UNKNOWN_KEY As Integer = (PA_ERR + 41)


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Defines for legal paper bins ticket printer series
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Public Const PA_CUT_ALL As String = "Cut on all pages"
    Public Const PA_CUT_2ND As String = "Cut every 2nd page"
    Public Const PA_CUT_3RD As String = "Cut every 3rd page"
    Public Const PA_CUT_4TH As String = "Cut every 4th page"
    Public Const PA_CUT_5TH As String = "Cut every 5th page"
    Public Const PA_CUT_LAST As String = "Cut on last page only"
    Public Const PA_NO_CUT As String = "Disable cutting"

    Public Const PA_MAX_BUFFER_SIZE As Integer = 1024
    Public Const DEFAULT_PIPE_TIMEOUT As Integer = 20000
    Public Const DEFAULT_STATUS_TIMEOUT As Integer = 20000

    ' PA status select constants
    Public Const PA_STAT_SHORT As Integer = 0
    Public Const PA_STAT_NORMAL As Integer = 1
    Public Const PA_STAT_EXTENDED As Integer = 2
    Public Const PA_STAT_COUNT As Integer = 3
    Public Const PA_STAT_TEMPERATURE As Integer = 4
    Public Const PA_STAT_FORMLENGTH As Integer = 5
    Public Const PA_STAT_COMPLETE As Integer = 6
    Public Const PA_STAT_LAST As Integer = 7
    Public Const PA_STAT_DOC_IN_PROGRESS As Integer = 8


    ' RFID Constants
    Public Const RFID_READER_NOT_DETERMINED = &H30     ' Reader presence unknown
    Public Const RFID_NO_READER = &H31                 ' No reader installed
    Public Const RFID_READER_NON_FUNCTIONAL = &H32     ' Reader installed, but not functional
    Public Const RFID_NO_STOCK = &H33                  ' Reader present, stock is OOP
    Public Const RFID_TAGLESS_STOCK = &H34             ' Non-RFID stock present.
    Public Const RFID_STOCK_LOADED = &H35              ' RFID stock present, but not ready
    Public Const RFID_TAG_READY = &H36                 ' RFID Tag in position for reading/writing
    Public Const RFID_TAG_FAULTY = &H37                ' cannot read a tag which should be there

    Public Const RFID_SUCCESS = &H30                    ' Operation complete; command specific data may follow
    Public Const RFID_BUSY = &H31                       ' Operation still in process
    Public Const RFID_FAILURE = &H32                    ' Operation failed
    Public Const RFID_CANCELLING = &H33                 ' A cancel command is in process
    Public Const RFID_CANCELLED = &H34                  ' A cancel operation is complete
    Public Const RFID_NO_STATUS = &H35                  ' No operation is in process for this query
    Public Const RFID_INVALID_COMMAND = &H36            ' Command and/or parameters invalid


    Public Function GetReturnCodeString(ByVal ErrorCode As Integer) As String
        Select Case ErrorCode
            Case PA_ERR_STATUS_TIMEOUT
                Return ("Status timeout - Considering increasing timeout parameter")

            Case PA_ERR_PRINTER_NOT_RESPONDING
                Return ("Printer not responding")

            Case PA_ERR_PIPE_TIMEOUT
                Return ("Pipe connect timeout")

            Case PA_ERR_PIPE_OPEN_BUSY
                Return ("Pipe open busy")

            Case PA_ERR_PIPE_OPEN_FAILED
                Return ("Pipe Open Failed")

            Case PA_ERR_PARAM1
                Return ("Error with Parameter 1")

            Case PA_ERR_PARAM2
                Return ("Error with Parameter 2")

            Case PA_ERR_PARAM3
                Return ("Error with Parameter 3")

            Case PA_ERR_PARAM4
                Return ("Error with Parameter 4")

            Case PA_ERR_SYSTEM
                Return ("Error reading or writing to the pipe/LM")

            Case PA_ERR_UNKNOWN_PRINTER
                Return ("LM does not support this function")

            Case PA_ERR_PRINTER_NOT_RESPONDING
                Return ("Printer not responding")

            Case Else
                Return ("Bad status from LM status read")
        End Select
    End Function

End Module
